// money.cpp
#include <iostream.h>
#include <iomanip.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "dynstrlb.h"

class money {
		String display;
		double value;
		String doub2str(double amount);
	public:
		money();
		money(double amount);
		~money();
		money &operator = (double amount);
		money &operator = (money &other);
		money operator + (money &right);
		friend ostream &operator << (ostream &stream, money &other);
};

String money::doub2str(double amount)
{
	float fraction;
	long whole, twodigits;
	char tmp[80],tmp1[80],tmp2[80],tmp3[80];
	int len=0,cnt=0,i=0,j=0;
	
	whole = amount;
	fraction = amount - whole;
	twodigits = (int) (fraction * 100);
	sprintf(tmp1,".%02d",twodigits);
	sprintf(tmp2,"%d",whole);
	
	// add commas
	cnt=0;
	len = strlen(tmp2);
	if (!(len%3))
		cnt = len + (len/3) - 1;
	else
		cnt = len + (len/3);
		
	tmp3[cnt] = '\0';
	cnt--; len--;
	for (i=len,j=0; i >= 0; i--,cnt--,j++)
	{
		if (j && !(j%3))
		{
			tmp3[cnt] = ',';
			cnt--;
		}
		
		tmp3[cnt] = tmp2[i];
	}
		
	sprintf(tmp,"%s%s",tmp3,tmp1);	
	return String(tmp);
}

money::money()
{
	display = "0.00";
	value = 0;
}

money::~money() { }

money::money(double amount)
{
	display = doub2str(amount);
	value = amount;
}

money &money::operator = (double amount)
{
	value = amount;
	display = doub2str(amount);	
	return *this;
}

money &money::operator = (money &other)
{
	if (this == &other)
		return *this;
	value = other.value;
	display = other.display;
 	return *this;
}

money money::operator + (money &right)
{
	money temp;
	temp.value = value + right.value;
	temp.display = doub2str(temp.value);
	return temp;
}

ostream &operator << (ostream &stream, money &other)
{
	stream << other.display;
	return stream;
}

void main()
{
	money register1, register2, total;
	register2 = register1 = 10200.5429;
	cout << "register1 holds " << register1 << endl;
	cout << "register2 holds " << register2 << endl;
	total = register1 + register2;
	cout << "total is " << total << endl;
}
