// ptr.cpp
#include <Memory.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>

int main()
{
	long left;
	
	MaxApplZone();  // grab all heap mem at startup
	left = FreeMem();
	cout << "Memory Available in Heap is " << left
	     << " bytes!" << endl;
	
	char *p = NewPtr(1000000);  // grab a Meg!
	if (!p)
	{
		cerr << "Allocation failed!" << endl;
		exit(0);
	}
	
	cout << "Allocated a Meg!" << endl;
	left = FreeMem();
	cout << "Memory Available in Heap is " << left
	     << " bytes!" << endl;

	DisposPtr(p); // free the mem
	cout << "Freed up a Meg!" << endl;
	left = FreeMem();
	cout << "Memory Available in Heap is " << left
	     << " bytes!" << endl;
	     
	return 0;	
}
