// union.cpp
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <stddef.h>

void main()
{
	union group {
		char mem[13];
		int iarr[3];
		float farr[3];
		int dummy;
	} sample;
	
	cout << "Size of sample union is " << sizeof(sample) << endl;
	cout << "  offset of mem is " << offsetof(group,mem) << endl;
	cout << "  offset of iarr is " << offsetof(group,iarr) << endl;
	cout << "  offset of farr is " << offsetof(group,farr) << endl;
	cout << "  offset of dummy is " << offsetof(group,dummy) << endl;
		
	// now we have 3 floats, 3 integers and 12 characters
	// occupying the same memory.
	
	sample.iarr[0] = 2; sample.iarr[1] = 3; 
	sample.iarr[2] = 4;
	cout << "Here are the integers:" << endl;
	cout << sample.iarr[0] << "," << sample.iarr[1]
	     << "," << sample.iarr[2] << endl;

	sample.farr[0] = 2.1; sample.farr[1] = 3.2; 
	sample.farr[2] = 4.3;
	cout << "Here are the floats:" << endl;
	cout << sample.farr[0] << "," << sample.farr[1]
	     << "," << sample.farr[2] << endl;

	strcpy(sample.mem,"Hello World.");
	cout << "Here are the characters:" << endl;
	cout << sample.mem << endl;	
}
