// hyperdct.h
#include "dynstrlb.h"

class HyperLink {
	protected:
		int *_links;
		int hyper_cnt;
		int hyper_max;
	public:
		HyperLink();
		~HyperLink();
		void addLink(int cell);
		int &operator [](int index);
		int numLinks();
};

class dictionary_entry {
	protected:
		String keyword;
		String *definition;
		int line_cnt;
		int line_max;
	public:
		HyperLink connect;
		dictionary_entry();
		~dictionary_entry();
		String get_keyword();
		friend ostream &operator << (ostream &stream, dictionary_entry &inobj);
		friend istream &operator >> (istream &stream, dictionary_entry &inobj);
		short word_exists(String& word);
		void LinkTo(int cousin);
};

class dictionary {
	protected:
		dictionary_entry *listing;
		int entry_count;
		int entry_max;
	public:
		dictionary();
		~dictionary();
		void add_entry();
		void delete_entry();
		void list_entries();
		void display_entry(int index);
		void find_entry();
};
