// matrix.cpp
#include <iostream.h>
#include <iomanip.h>

void main()
{
	int sales[3][4] = { {10,22,43,22}, 
						{33,11,43,55},
						{54,56,76,59} };
	int *ip;
	int **ipp;     // WRONG
	int (*ip4)[4]; // RIGHT
	int i,j;       // loop variables
	
	ip4 = sales;           // no problem, correct pointer assignment
	ip = (int *) sales;    // need to cast because sales is an
	                       // array of arrays.
	ipp = (int **) sales;  // you can cast but this is WRONG!!


	cout << "size of *ip is " << sizeof(*ip) << endl;
	cout << "size of *ipp is " << sizeof(*ipp) << endl;
	cout << "size of *ip4 is " << sizeof(*ip4) << endl;
	
	// *** let's first see how the data is stored ***
	cout << "Storage of data:" << endl;
	for (i=0; i < 12; i++)
		cout << ip[i] << " ";
	cout << endl;
	cout << endl;
	
	// *** now let's see how we like to view it ***
	cout << "Matrix concept:" << endl;
	for (i=0; i < 3; i++)
	{
		for (j=0; j < 4; j++)
		{
			cout << *(*(ip4 + i) + j) << " ";
			// same as sales[i][j]
			// same as *(*(sales + i) + j)
		}
		cout << endl;
	}
}
