// cmdline.cpp
#include <iostream.h>
#include <iomanip.h>

/* the next include is only necessary to allow
	command line arguments in THINK C */

#ifdef __SC__
#include <console.h>
#endif

/* ***********************************************************
     FUNCTION NAME:  main for cmd_line.c
     PURPOSE:  demonstrate how argv is a pointer pointer.
     INPUT:  none.
     OUTPUT:  none.
     AUTHOR: MCD
    ************************************************************ */
void main(int argc, char *argv[])
{
	int i,j;

	char **my_arg=0;
	
	/* the next statement is just THINK C's way of allowing
	command line arguments in the mac's window environment. */	
#ifdef __SC__
	argc = ccommand(&argv);
#endif
	
	my_arg = argv;
	
	// print out as strings
	for (i=0; i<argc; i++)
		cout << "argv[" << i << "] = "
		     << my_arg[i] << endl;
		
	/* print out as characters */
	for (i=0; i<argc; i++)
	{
		/* wouldn't it have been easier if they made the
		argv pointer pointer NULL terminated? */
		for (j=0; *((*(my_arg+i)) + j); j++)
			cout << "character[" << j << "] of the row["
			     << i << "] is " << my_arg[i][j]
			                     << "." << endl;
	}
}
